﻿Type=Activity
Version=5.78
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private flgChanged As Boolean
	Private strDatabase As String
	Private flgConnesso As Boolean = False
	Private Pegaso As MySQL
		 
	Private cmdEsci As Button
	Private cmdLeggiDB As Button
	Private cmdSalva As Button
	Private cmdTestIP As Button
	Private lstDatabase As ListView
	Private txtIP As EditText
	Private txtPassword As EditText
	Private txtPort As EditText
	Private txtUtente As EditText
	Private lblNomeDatabase As Label
	Private lblIP As Label
	Private lblPort As Label
	Private lblUtente As Label
	Private lblPassword As Label
	Private lblDBdaUsare As Label
	Private lblDatabase As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	
	Activity.LoadLayout("frmConfigMySQL")

	Log("Config " & Density)
	Log(Activity.Width & " * " & Activity.Height)

	strDatabase = ""
	cmdTestIP.Enabled = False 
	cmdLeggiDB.Enabled = False
	cmdSalva.Enabled = False
	
	txtIP.Text = StateManager.GetSetting2("IP","")
	txtPort.Text = StateManager.GetSetting2("Port","")
	txtUtente.Text = StateManager.GetSetting2("Utente","")
	txtPassword.Text = StateManager.GetSetting2("Password","")
	lblNomeDatabase.Text = StateManager.GetSetting2("Database","")
	flgConnesso = False
	
	Dim cntOK As Int
	cntOK = 0
	If txtIP.Text.Trim <> "" Then cntOK = cntOK +1
	If txtPort.Text.Trim <> "" Then cntOK = cntOK +1
	If txtUtente.Text.Trim <> "" Then cntOK = cntOK +1
	If txtPassword.Text.Trim <> "" Then cntOK = cntOK +1
	If cntOK = 4 Then cmdTestIP.Enabled = True

	lstDatabase.Color = Colors.DarkGray

	flgChanged = False
	
	Log("Salva:")
	Log("Pos: " & cmdTestIP.Left & "." & cmdTestIP.Top)
	Log("Size: " & cmdTestIP.width & "*" & cmdTestIP.Height)
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	Log("Utente chiude Configura")
	If UserClosed = True Then 
		If flgConnesso = True Then Pegaso.CloseDatabase
	End If
End Sub

Sub txtUtente_TextChanged (Old As String, New As String)
	AbilitaConnetti
End Sub

Sub AbilitaConnetti
	Dim cntOK As Int
	
	flgChanged = True
	cntOK = 0
	If txtIP.Text.Trim <> "" Then cntOK = cntOK +1
	If txtPort.Text.Trim <> "" Then cntOK = cntOK +1
	If txtUtente.Text.Trim <> "" Then cntOK = cntOK +1
	If txtPassword.Text.Trim <> "" Then cntOK = cntOK +1
	If cntOK = 4 Then cmdTestIP.Enabled = True
 	cmdSalva.Enabled = False
	lstDatabase.Clear
	cmdLeggiDB.Enabled = False
	If flgConnesso = True Then Pegaso.CloseDatabase
End Sub

Sub txtUtente_EnterPressed
	txtUtente.RequestFocus
End Sub

Sub txtPort_TextChanged (Old As String, New As String)
	AbilitaConnetti
End Sub

Sub txtPort_EnterPressed
	txtPort.RequestFocus
End Sub

Sub txtPassword_TextChanged (Old As String, New As String)
	AbilitaConnetti
End Sub

Sub txtPassword_EnterPressed
	txtPassword.RequestFocus
End Sub

Sub txtIP_TextChanged (Old As String, New As String)
	AbilitaConnetti
End Sub

Sub txtIP_EnterPressed
	txtIP.RequestFocus	
End Sub

Sub lstDatabase_ItemClick (Position As Int, Value As Object)
	lstDatabase.RequestFocus
	If strDatabase <> lstDatabase.GetItem(Position) Then
		strDatabase = lstDatabase.GetItem(Position)
		flgChanged = True	
		cmdSalva.Enabled = True
		lblNomeDatabase.Text = strDatabase
	End If
End Sub

Sub cmdTestIP_Click
	Pegaso.Initialize("Pegaso",txtIP.Text.trim  & ":" & txtPort.Text.Trim,txtUtente.Text.trim, txtPassword.Text.Trim,"", True, True)
End Sub

Sub Pegaso_Status(Connected As Boolean, ReConnecting As Boolean, RetriesLeft As Int)
	flgConnesso = Connected
	If flgConnesso = True Then
		ToastMessageShow("Connesso", False)
		cmdLeggiDB.Enabled = True
	Else
		ToastMessageShow("Mancata Connessione", False)
		cmdLeggiDB.Enabled = False
    End If
End Sub

Sub Pegaso_QueryResult(data As List, meta As Map)
	Log(meta)
	Select meta.Get("TaskID") 
		Case "Database"
			cmdSalva.Enabled = False
			Log(data)
			For Each Record As Map In data
				Select Record.Get("NOME_DB") 
					Case "information_schema"
					Case "mysql"
					Case "performance_schema"
					Case Else
						lstDatabase.AddSingleLine(Record.Get("NOME_DB"))			
				End Select
			Next
	End Select
End Sub

Sub cmdSalva_Click
	Log(StateManager.settingsFileName)
	Log(StateManager.SetSetting("IP",txtIP.Text))
	Log(StateManager.SetSetting("Port",txtPort.Text))
	Log(StateManager.SetSetting("Utente",txtUtente.Text))
	Log(StateManager.SetSetting("Password",txtPassword.Text))
	Log(StateManager.SetSetting("Database",strDatabase))
	StateManager.SaveSettings
	Activity.Finish
End Sub

Sub cmdLeggiDB_Click
	lstDatabase.Clear
	ToastMessageShow("Leggo Lista Database",False)
	Pegaso.QueryASync("SELECT SCHEMA_NAME AS NOME_DB FROM information_schema.SCHEMATA ORDER BY SCHEMA_NAME","Database")
End Sub

Sub cmdEsci_Click
	If flgChanged = True Then
		Dim risposta As Int
		risposta = Msgbox2("Sicuro?","Avviso...","Rimango","","Esco", LoadBitmap(File.DirAssets, "help.png"))
		If risposta = DialogResponse.NEGATIVE Then
			Activity.Finish
		End If
	Else
		Activity.Finish
	End If
End Sub